diff --git a/lib/pipeline/rte_swx_pipeline.c b/lib/pipeline/rte_swx_pipeline.c
index 3e1c6e9edb..52760111fd 100644
--- a/lib/pipeline/rte_swx_pipeline.c
+++ b/lib/pipeline/rte_swx_pipeline.c
@@ -18,6 +18,7 @@
 #include <rte_swx_table_wm.h>
 
 #include "rte_swx_pipeline_internal.h"
+#include "rte_swx_pipeline_spec.h"
 
 #define CHECK(condition, err_code)                                             \
 do {                                                                           \
@@ -13476,3 +13477,96 @@ pipeline_compile(struct rte_swx_pipeline *p)
 
 	return status;
 }
+
+int
+rte_swx_pipeline_codegen(FILE *spec_file,
+			 FILE *code_file,
+			 uint32_t *err_line,
+			 const char **err_msg)
+
+{
+	struct rte_swx_pipeline *p = NULL;
+	struct pipeline_spec *s = NULL;
+	struct instruction_group_list *igl = NULL;
+	struct action *a;
+	int status = 0;
+
+	/* Check input arguments. */
+	if (!spec_file || !code_file) {
+		if (err_line)
+			*err_line = 0;
+		if (err_msg)
+			*err_msg = "Invalid input argument.";
+		status = -EINVAL;
+		goto free;
+	}
+
+	/* Pipeline configuration. */
+	s = pipeline_spec_parse(spec_file, err_line, err_msg);
+	if (!s) {
+		status = -EINVAL;
+		goto free;
+	}
+
+	status = rte_swx_pipeline_config(&p, 0);
+	if (status) {
+		if (err_line)
+			*err_line = 0;
+		if (err_msg)
+			*err_msg = "Pipeline configuration error.";
+		goto free;
+	}
+
+	status = pipeline_spec_configure(p, s, err_msg);
+	if (status) {
+		if (err_line)
+			*err_line = 0;
+		goto free;
+	}
+
+	/*
+	 * Pipeline code generation.
+	 */
+
+	/* Instruction Group List (IGL) computation: the pipeline configuration must be done first,
+	 * but there is no need for the pipeline build to be done as well.
+	 */
+	igl = instruction_group_list_create(p);
+	if (!igl) {
+		if (err_line)
+			*err_line = 0;
+		if (err_msg)
+			*err_msg = "Memory allocation failed.";
+		status = -ENOMEM;
+		goto free;
+	}
+
+	/* Header file inclusion. */
+	fprintf(code_file, "#include \"rte_swx_pipeline_internal.h\"\n");
+	fprintf(code_file, "#include \"rte_swx_pipeline_spec.h\"\n\n");
+
+	/* Code generation for the pipeline specification. */
+	pipeline_spec_codegen(code_file, s);
+	fprintf(code_file, "\n");
+
+	/* Code generation for the action instructions. */
+	TAILQ_FOREACH(a, &p->actions, node) {
+		fprintf(code_file, "/**\n * Action %s\n */\n\n", a->name);
+
+		action_data_codegen(a, code_file);
+		fprintf(code_file, "\n");
+
+		action_instr_codegen(a, code_file);
+		fprintf(code_file, "\n");
+	}
+
+	/* Code generation for the pipeline instructions. */
+	instruction_group_list_codegen(igl, p, code_file);
+
+free:
+	instruction_group_list_free(igl);
+	rte_swx_pipeline_free(p);
+	pipeline_spec_free(s);
+
+	return status;
+}
diff --git a/lib/pipeline/rte_swx_pipeline.h b/lib/pipeline/rte_swx_pipeline.h
index c41ca5cb15..2bd019b05f 100644
--- a/lib/pipeline/rte_swx_pipeline.h
+++ b/lib/pipeline/rte_swx_pipeline.h
@@ -941,6 +941,31 @@ __rte_experimental
 int
 rte_swx_pipeline_build(struct rte_swx_pipeline *p);
 
+/**
+ * Pipeline C code generate based on input specification file
+ *
+ * @param[in] spec_file
+ *   Pipeline specification file (.spec) provided as input.
+ * @param[in] code_file
+ *   Pipeline C language file (.c) to be generated.
+ * @param[out] err_line
+ *   In case of error and non-NULL, the line number within the *spec* file where
+ *   the error occurred. The first line number in the file is 1.
+ * @param[out] err_msg
+ *   In case of error and non-NULL, the error message.
+ * @return
+ *   0 on success or the following error codes otherwise:
+ *   -EINVAL: Invalid argument;
+ *   -ENOMEM: Not enough space/cannot allocate memory;
+ *   -EEXIST: Resource with the same name already exists.
+ */
+__rte_experimental
+int
+rte_swx_pipeline_codegen(FILE *spec_file,
+			 FILE *code_file,
+			 uint32_t *err_line,
+			 const char **err_msg);
+
 /**
  * Pipeline build from specification file
  *
diff --git a/lib/pipeline/version.map b/lib/pipeline/version.map
index 8312307a7a..51165d48cf 100644
--- a/lib/pipeline/version.map
+++ b/lib/pipeline/version.map
@@ -145,4 +145,7 @@ EXPERIMENTAL {
 	rte_swx_ctl_pipeline_learner_timeout_get;
 	rte_swx_ctl_pipeline_learner_timeout_set;
 	rte_swx_pipeline_hash_func_register;
+
+	#added in 22.11
+	rte_swx_pipeline_codegen;
 };